<template>
  <div class="desktop">
    <div class="referral-program-table-container"
         v-if="referralRecords.length > 0">
      <table class="referral-program-table">
        <thead>
        <tr>
          <th>{{ $t('bounty.referral.email') }}</th>
          <th>{{ $t('common.heta_tokens') }}</th>
          <th>{{ $t('bounty.referral.type') }}</th>
          <th>{{ $t('bounty.referral.time') }}</th>
        </tr>
        </thead>
        <tbody>
        <tr v-for="(record, index) in referralRecords" :key="index">
          <td>{{ record.meta_data}}</td>
          <td>{{ record.heta_tokens | formatCurrencyAmount('heta', '0') }}</td>
          <td>{{ record.type | referralType}}</td>
          <td>{{ record.created_at | formatDateUTCtoLocal}}</td>
        </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
  import rf from '../../../../common/requests/RequestFactory';
  import moment from 'moment';

  export default {
    data () {
      return {
        referralRecords: [],
        pagination: {},
        perPage: 10,
        totalPage: 0,
        lastPage: 1,
      }
    },
    filters: {
      referralType (value) {
        return _.chain(value)
          .lowerCase()
          .upperFirst()
          .value();
      },

      formatDateUTCtoLocal(value, format = 'YYYY-MM-DD HH:mm:ss') {
        if (!value) {
          return null;
        }
        return moment(value).local().format(format);
      }
    },
    computed: {
      isVersionDesktop () {
        return this.version === 'desktop';
      },
    },
    methods: {
      getReferralProgramRecords () {
        const params = {
          'limit': this.perPage,
          'page': this.pagination.currentPage
        };

        rf.getRequest('UserRequest').getReferralProgramRecords(params)
          .then((res) => {
            this.referralRecords = res.data;
            this.totalPage = res.meta.total;
            this.lastPage = res.meta.last_page;
          });
      },
    },
    created () {
      this.getReferralProgramRecords();
    }
  }
</script>

<style lang="scss" scoped>
@import '../../../../../sass/variables';
  .desktop {
    .referral-program-table-container {
      margin-top: 50px;
      margin-bottom: -6px;
      width: 100%;
      max-width: 1130px;
      border-radius: 3px;
      background-color: #ffffff;
      border: 1px solid #d2d2d2;
      .referral-program-table {
        width: 100%;
        thead {
          display: table;
          width: 100%;
          font-size: 14px;
          color: rgb(34, 44, 60);
          background-color: #efefef;
          table-layout: fixed;
          th {
            height: 39px;
            text-align: left;
            border-bottom: 2px solid #ebebeb;
            padding: 12px 0 12px 55px;
          }
        }
        tbody {
          display: block;
          width: 100%;
          max-height: 300px;
          overflow-y: auto;
          tr {
            display: table;
            width: 100%;
            table-layout: fixed;

          }
          td {
            height: 39px;
            font-size: 13px;
            color: #222c3c;
            font-weight: 300;
            border-bottom: 1px solid #ebebeb;
            padding: 15px 0 15px 62px;
            &.total {
              font-size: 14px;
              color: rgb(34, 44, 60);
              font-weight: 700;
            }
          }
        }
      }
    }
  }
  .mobile {
    .user-refer-table-row {
      display: inline-block;
      width: 100%;
      height: 2.05rem;
    }
    .user-refer-table-col {
      display: inline-block;
      line-height: 2rem;
      float: left;
      font-size: 13px;
      height: 2rem;
      overflow: hidden;
      text-overflow: ellipsis;
      border-bottom: 1px solid #ebebeb;
      text-align: center;
      &.email {
        width: 40%;
      }
      &.tokens {
        width: 20%;
      }
      &.type {
        width: 40%;
      }
    }
    .product__paginate {
      display: block;
      text-align: center;
      margin-top: 10px;
    }
  }
</style>
